<template>
  <div
    v-if="displayPagination"
    class="pagination"
  >
    <button
      :class="disabledFirstPageButton ? 'button-off' : 'button-pagination'"
      :title="$t('pagination.firstPage')"
      @click="goToFirstPage"
    >
      &lt;&lt;
    </button>
    <button
      :class="disabledPreviousPageButton ? 'button-off' : 'button-pagination'"
      :title="$t('pagination.previousPage')"
      @click="goToPreviousPage"
    >
      &lt;
    </button>
    <span class="mx-2">Page {{ currentPage }} / {{ maxPages }}</span>
    <button
      :class="disabledNextPageButton ? 'button-off' : 'button-pagination'"
      :title="$t('pagination.nextPage')"
      @click="goToNextPage"
    >
      &gt;
    </button>
    <button
      :class="disabledLastPageButton ? 'button-off' : 'button-pagination'"
      :title="$t('pagination.lastPage')"
      @click="goToLastPage"
    >
      &gt;&gt;
    </button>
  </div>
</template>

<script>
import { computed, watchEffect } from 'vue'
export default {
  name: 'Pagination',
  props: {
    modelValue: {
      type: Number,
      default: 1
    },
    maxPages: {
      type: Number,
      default: 1
    }
  },
  setup (props, context) {
    const currentPage = computed({ 
      get: () => props.modelValue, 
      set: (value) => context.emit('update:modelValue', value)
    }) 
    
    const displayPagination = computed(() => (props.maxPages > 1))
    const disabledFirstPageButton = computed(() => (currentPage.value === 1))
    const disabledPreviousPageButton = computed(() => (currentPage.value === 1))
    const disabledLastPageButton = computed(() => (currentPage.value === props.maxPages))
    const disabledNextPageButton = computed(() => (currentPage.value === props.maxPages))

    watchEffect(() => {
      if (currentPage.value > props.maxPages) {
        currentPage.value = props.maxPages
      }
      if (currentPage.value < 1) {
        currentPage.value = 1
      }
    })

    const goToFirstPage = () => {
      currentPage.value = 1
    }

    const goToPreviousPage = () => {
        currentPage.value--
    }

    const goToNextPage = () => {
        currentPage.value++
    }

    const goToLastPage = () => {
      currentPage.value = props.maxPages
    }

    return {
      currentPage,
      displayPagination,
      disabledFirstPageButton,
      disabledPreviousPageButton,
      disabledNextPageButton,
      disabledLastPageButton,
      goToFirstPage,
      goToPreviousPage,
      goToNextPage,
      goToLastPage,
    }
  }
}
</script>

<style lang="postcss" scoped>
.pagination {
  @apply flex justify-center items-center;
  @apply w-3/5 h-10 my-5 mx-auto;
  @apply bg-white text-purple-400 font-semibold;
  @apply dark:bg-gray-800;
  @apply border border-purple-100 shadow rounded;
  @apply dark:border-purple-900 dark:shadow-purple-900
}

.button-pagination {
  @apply w-8 h-8;
  @apply text-sm font-bold;
}

.button-pagination:hover {
  @apply w-8 h-8;
  @apply bg-purple-100;
  @apply dark:bg-purple-900;
  @apply rounded-full;
}

.button-off {
  @apply w-8 h-8;
  @apply text-gray-300 text-sm font-bold;
  @apply dark:text-gray-700;
  @apply pointer-events-none;
}
</style>